import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * Write a description of class TicketMachinePanel here.
 * 
 * @author John Pagliarulo
 * @version October 25, 2004
 */
public class TicketMachinePanel extends JPanel
{
   private TicketMachine machine;
   
   // GUI Components
   private JLabel inputLabel;
   private JLabel outputLabel;
   private JTextField moneySlot;
   private JButton buyButton;
   
    /**
     * Constructor for objects of class TicketMachinePanel
     */
    public TicketMachinePanel(TicketMachine machine)
    {
      this.machine = machine;  //connect GUI to machine
      setPreferredSize(new Dimension(200, 200));
      
      // Build GUI
      inputLabel = new JLabel("Insert money here and press Enter: ");
      outputLabel = new JLabel("Total amount inserted: 0");
      moneySlot = new JTextField(5);
      buyButton = new JButton("Press to buy ticket");
      
      add(inputLabel);
      add(moneySlot);
      add(outputLabel);
      add(buyButton);
      
      moneySlot.addActionListener(new MoneyListener());
      buyButton.addActionListener(new BuyListener());
    } // TicketMachinePanel ctor
      
      private class MoneyListener implements ActionListener
      {
          public void actionPerformed(ActionEvent evt)
          {
              int amountInserted = Integer.parseInt(moneySlot.getText());
              if (amountInserted > 0){
                  machine.insertMoney(amountInserted);
                  outputLabel.setText("Total amount inserted: " + machine.getBalance());
              }
              else {
                  outputLabel.setText("You must insert a positive amount");
              }
              moneySlot.setText("");
          }
      } // MoneyListener

      private class BuyListener implements ActionListener
      {
          public void actionPerformed(ActionEvent evt)
          {
              int amountNeeded = machine.getPrice() - machine.getBalance();
              
              if (amountNeeded <= 0){
                  machine.printTicket();
                  outputLabel.setText("Take your ticket. Change: " + machine.refundBalance());
              }
              else {
                  outputLabel.setText("You must insert " + amountNeeded + " more");
              }       
          }
      } // BuyListener
}
